# include "Ximage.h"

void CreateZoom8 (KapaImageWidget *image, Graphic *graphic, double x, double y) {

# if (0)
  int i, j, ii, jj;
  int i_start, i_end, j_start, j_end;
  int dropback;  /* this is a bit of a kludge... */
  int dx, dy, DX, DY, pixelN;
  double expand, zoomscale, Rx, Ry;
  int expand_in, expand_out;
  unsigned char *out_pix, *out_pix2;
  float *imdata, *in_pix, *in_pix2;
  unsigned long pixel[256], pixvalue;
  unsigned long back;

  if (image[0].image[0].matrix.size == 0) {  /* create a test pattern */
    REALLOCATE (image[0].zoom.data, char, image[0].zoom.dx*image[0].zoom.dy);
    bzero (image[0].zoom.data, image[0].zoom.dx*image[0].zoom.dy);
    image[0].zoom.pix = XCreateImage (graphic[0].display, graphic[0].visual, graphic[0].depth, ZPixmap, 0, 
				       image[0].zoom.data, image[0].zoom.dx, image[0].zoom.dy, 8, 0);
    return;
  }

  for (i = 0; i < 256; i++) { /* set up pixel array */
    pixel[i] = graphic[0].cmap[i].pixel;
  }
  back = graphic[0].back;

  // define the color transform parameters
  MaxValue = graphic[0].Npixels - 1;
  if (image[0].image[0].range != 0.0) {
    slope = graphic[0].Npixels / image[0].image[0].range;
    start = graphic[0].Npixels * image[0].image[0].zero / image[0].image[0].range;
  } else {
    slope = 1.0;
    start = image[0].image[0].zero;
  }

  zoomscale = MAX (5, image[0].expand + 5);
  expand = 1 / zoomscale;
  expand_out = (int) zoomscale;
  expand_in  = 1;

  dx = image[0].zoom.dx;
  dy = image[0].zoom.dy;
  DX = image[0].image[0].matrix.Naxis[0];
  DY = image[0].image[0].matrix.Naxis[1];
  Rx = x - expand*(int)(0.5*(dx + 1)) + 1;
  Ry = y - expand*(int)(0.5*(dy + 1)) + 1;

  i_start = MIN (MAX (-Rx / expand, (1 - FRAC(Rx)) / expand), dx - expand_out + 1);
  j_start = MIN (MAX (-Ry / expand, (1 - FRAC(Ry)) / expand), dy - expand_out + 1);
  i_end   = MAX (MIN ((DX-Rx) / expand, dx - expand_out + 1), 0);
  j_end   = MAX (MIN ((DY-Ry) / expand, dy - expand_out + 1), 0);
  dropback = expand_out - (i_end - i_start) % expand_out;
  if ((i_end - i_start) % expand_out == 0) dropback = 0;

  out_pix = (unsigned char *) image[0].zoom.data;
  imdata  = (float *) image[0].image[0].matrix.buffer;
  in_pix  = &imdata[DX*(int)MAX(Ry,0) + (int)MAX(Rx,0)];

  /********** below we do the mapping from buffer pixels (in) to picture pixels (out) **********/

  if ((i_end < i_start) || (j_end < j_start)) {
    for (j = 0; j < dx*dy; j++, out_pix++) 
      *out_pix = back;
    return;
  } 
  
  /**** fill in bottom area ****/
  for (j = 0; j < dx*j_start; j++, out_pix++) 
    *out_pix = back;
  
  for (j = j_start; j < j_end; j+= expand_out, out_pix+=(expand_out-1)*dx, in_pix += expand_in*DX) {

    /**** fill in area to the left of the picture ****/
    for (jj = 0; jj < expand_out; jj++) { 
      out_pix2 = out_pix + jj*dx;
      for (i = 0; i < i_start; i++, out_pix2++) {
	*out_pix2 = back;
      }
    }
    out_pix += i_start;
    
    /*** fill in the picture region ***/
    in_pix2 = in_pix;
    if (expand_out == 1) {
      for (i = i_start; i < i_end; i++, in_pix2+= expand_in, out_pix++) {
	pixelN = PixelLookup(*in_pix2);
	*out_pix = pixel[pixelN];
      }
    } else {
      for (i = i_start; i < i_end; i+= expand_out, in_pix2++, out_pix+= expand_out) { 
	pixelN   = PixelLookup(*in_pix2);
	pixvalue = pixel[pixelN];
	out_pix2 = out_pix;
	for (jj = 0; jj < expand_out; jj++, out_pix2+=(dx-expand_out)) {
	  for (ii = 0; ii < expand_out; ii++, out_pix2++) {
	    *out_pix2 = pixvalue;
	  }
	}
      }
    }
    out_pix -= dropback;
    
    /**** fill in area to the right of the picture ****/
    for (jj = 0; jj < expand_out; jj++) {
      out_pix2 = out_pix + jj*dx;
      for (i = i_end; i < dx; i++, out_pix2++) {
	*out_pix2 = back;
      }
    }
    out_pix += (dx - i_end);
    
  } 
  
  if ((j_end - j_start) % expand_out > 0)
    out_pix -= expand_out - (j_end - j_start) % expand_out;
  
  /**** fill in top area ****/
  for (j = 0; (j < dx*(dy - j_end)) && (out_pix - (unsigned char *) image[0].zoom.data < dx*dy); j++, out_pix++) { 
    *out_pix = back;
  }

  image[0].zoom.pix = XCreateImage (graphic[0].display, graphic[0].visual, graphic[0].depth, ZPixmap, 0, 
					image[0].zoom.data, image[0].zoom.dx, image[0].zoom.dy, 8, 0);
  
# endif
}
